diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/class.wp-dependencies.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class.wp-dependencies.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/class.wp-dependencies.php	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class.wp-dependencies.php	2012-12-17 16:18:39.000000000 -0600
***************
*** 196,219 ****
  		}
  	}
  
! 	function query( $handle, $list = 'registered' ) { // registered, queue, done, to_do
! 		switch ( $list ) :
! 		case 'registered':
! 		case 'scripts': // back compat
! 			if ( isset($this->registered[$handle]) )
! 				return $this->registered[$handle];
! 			break;
! 		case 'to_print': // back compat
! 		case 'printed': // back compat
! 			if ( 'to_print' == $list )
! 				$list = 'to_do';
! 			else
! 				$list = 'printed';
! 		default:
! 			if ( in_array($handle, $this->$list) )
! 				return true;
! 			break;
! 		endswitch;
  		return false;
  	}
  
--- 196,222 ----
  		}
  	}
  
! 
! 	function query( $handle, $list = 'registered' ) {
! 		switch ( $list ) {
! 			case 'registered' :
! 			case 'scripts': // back compat
! 				if ( isset( $this->registered[ $handle ] ) )
! 					return $this->registered[ $handle ];
! 				return false;
! 
! 			case 'enqueued' :
! 			case 'queue' :
! 				return in_array( $handle, $this->queue );
! 
! 			case 'to_do' :
! 			case 'to_print': // back compat
! 				return in_array( $handle, $this->to_do );
! 
! 			case 'done' :
! 			case 'printed': // back compat
! 				return in_array( $handle, $this->done );
! 		}
  		return false;
  	}
  
***************
*** 244,251 ****
  	var $extra = array();
  
  	function __construct() {
! 		@list($this->handle, $this->src, $this->deps, $this->ver, $this->args) = func_get_args();
! 		if ( !is_array($this->deps) )
  			$this->deps = array();
  	}
  
--- 247,254 ----
  	var $extra = array();
  
  	function __construct() {
! 		@list( $this->handle, $this->src, $this->deps, $this->ver, $this->args ) = func_get_args();
! 		if ( ! is_array($this->deps) )
  			$this->deps = array();
  	}
  
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/class-wp-editor.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class-wp-editor.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/class-wp-editor.php	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class-wp-editor.php	2012-12-17 16:18:39.000000000 -0600
***************
*** 32,40 ****
  			'wpautop' => true, // use wpautop?
  			'media_buttons' => true, // show insert/upload button(s)
  			'textarea_name' => $editor_id, // set the textarea name to something different, square brackets [] can be used here
! 			'textarea_rows' => get_option('default_post_edit_rows', 10), // rows="..."
  			'tabindex' => '',
! 			'editor_css' => '', // intended for extra styles for both visual and HTML editors buttons, needs to include the <style> tags, can use "scoped".
  			'editor_class' => '', // add extra class(es) to the editor textarea
  			'teeny' => false, // output the minimal editor config used in Press This
  			'dfw' => false, // replace the default fullscreen with DFW (needs specific DOM elements and css)
--- 32,41 ----
  			'wpautop' => true, // use wpautop?
  			'media_buttons' => true, // show insert/upload button(s)
  			'textarea_name' => $editor_id, // set the textarea name to something different, square brackets [] can be used here
! 			'textarea_rows' => 20,
  			'tabindex' => '',
! 			'tabfocus_elements' => ':prev,:next', // the previous and next element ID to move the focus to when pressing the Tab key in TinyMCE
! 			'editor_css' => '', // intended for extra styles for both visual and Text editors buttons, needs to include the <style> tags, can use "scoped".
  			'editor_class' => '', // add extra class(es) to the editor textarea
  			'teeny' => false, // output the minimal editor config used in Press This
  			'dfw' => false, // replace the default fullscreen with DFW (needs specific DOM elements and css)
***************
*** 51,56 ****
--- 52,79 ----
  		if ( self::$this_quicktags )
  			self::$has_quicktags = true;
  
+ 		if ( empty( $set['editor_height'] ) )
+ 			return $set;
+ 
+ 		if ( 'content' === $editor_id ) {
+ 			// A cookie (set when a user resizes the editor) overrides the height.
+ 			$cookie = (int) get_user_setting( 'ed_size' );
+ 
+ 			// Upgrade an old TinyMCE cookie if it is still around, and the new one isn't.
+ 			if ( ! $cookie && isset( $_COOKIE['TinyMCE_content_size'] ) ) {
+ 				parse_str( $_COOKIE['TinyMCE_content_size'], $cookie );
+  				$cookie = $cookie['ch'];
+ 			}
+ 
+ 			if ( $cookie )
+ 				$set['editor_height'] = $cookie;
+ 		}
+ 
+ 		if ( $set['editor_height'] < 50 )
+ 			$set['editor_height'] = 50;
+ 		elseif ( $set['editor_height'] > 5000 )
+ 			$set['editor_height'] = 5000;
+ 
  		return $set;
  	}
  
***************
*** 66,81 ****
  		$set = self::parse_settings($editor_id, $settings);
  		$editor_class = ' class="' . trim( $set['editor_class'] . ' wp-editor-area' ) . '"';
  		$tabindex = $set['tabindex'] ? ' tabindex="' . (int) $set['tabindex'] . '"' : '';
- 		$rows = ' rows="' . (int) $set['textarea_rows'] . '"';
  		$switch_class = 'html-active';
  		$toolbar = $buttons = '';
  
  		if ( !current_user_can( 'upload_files' ) )
  			$set['media_buttons'] = false;
  
  		if ( self::$this_quicktags && self::$this_tinymce ) {
  			$switch_class = 'html-active';
  
  			if ( 'html' == wp_default_editor() ) {
  				add_filter('the_editor_content', 'wp_htmledit_pre');
  			} else {
--- 89,109 ----
  		$set = self::parse_settings($editor_id, $settings);
  		$editor_class = ' class="' . trim( $set['editor_class'] . ' wp-editor-area' ) . '"';
  		$tabindex = $set['tabindex'] ? ' tabindex="' . (int) $set['tabindex'] . '"' : '';
  		$switch_class = 'html-active';
  		$toolbar = $buttons = '';
  
+ 		if ( ! empty( $set['editor_height'] ) )
+ 			$height = ' style="height: ' . $set['editor_height'] . 'px"';
+ 		else
+ 			$height = ' rows="' . $set['textarea_rows'] . '"';
+ 
  		if ( !current_user_can( 'upload_files' ) )
  			$set['media_buttons'] = false;
  
  		if ( self::$this_quicktags && self::$this_tinymce ) {
  			$switch_class = 'html-active';
  
+ 			// 'html' and 'switch-html' are used for the "Text" editor tab.
  			if ( 'html' == wp_default_editor() ) {
  				add_filter('the_editor_content', 'wp_htmledit_pre');
  			} else {
***************
*** 83,93 ****
  				$switch_class = 'tmce-active';
  			}
  
! 			$buttons .= '<a id="' . $editor_id . '-html" class="hide-if-no-js wp-switch-editor switch-html" onclick="switchEditors.switchto(this);">' . __('HTML') . "</a>\n";
! 			$buttons .= '<a id="' . $editor_id . '-tmce" class="hide-if-no-js wp-switch-editor switch-tmce" onclick="switchEditors.switchto(this);">' . __('Visual') . "</a>\n";
  		}
  
! 		echo '<div id="wp-' . $editor_id . '-wrap" class="wp-editor-wrap ' . $switch_class . '">';
  
  		if ( self::$editor_buttons_css ) {
  			wp_print_styles('editor-buttons');
--- 111,121 ----
  				$switch_class = 'tmce-active';
  			}
  
! 			$buttons .= '<a id="' . $editor_id . '-html" class="wp-switch-editor switch-html" onclick="switchEditors.switchto(this);">' . _x( 'Text', 'Name for the Text editor tab (formerly HTML)' ) . "</a>\n";
! 			$buttons .= '<a id="' . $editor_id . '-tmce" class="wp-switch-editor switch-tmce" onclick="switchEditors.switchto(this);">' . __('Visual') . "</a>\n";
  		}
  
! 		echo '<div id="wp-' . $editor_id . '-wrap" class="wp-core-ui wp-editor-wrap ' . $switch_class . '">';
  
  		if ( self::$editor_buttons_css ) {
  			wp_print_styles('editor-buttons');
***************
*** 98,104 ****
  			echo $set['editor_css'] . "\n";
  
  		if ( !empty($buttons) || $set['media_buttons'] ) {
! 			echo '<div id="wp-' . $editor_id . '-editor-tools" class="wp-editor-tools">';
  			echo $buttons;
  
  			if ( $set['media_buttons'] ) {
--- 126,132 ----
  			echo $set['editor_css'] . "\n";
  
  		if ( !empty($buttons) || $set['media_buttons'] ) {
! 			echo '<div id="wp-' . $editor_id . '-editor-tools" class="wp-editor-tools hide-if-no-js">';
  			echo $buttons;
  
  			if ( $set['media_buttons'] ) {
***************
*** 107,120 ****
  				if ( !function_exists('media_buttons') )
  					include(ABSPATH . 'wp-admin/includes/media.php');
  
! 				echo '<div id="wp-' . $editor_id . '-media-buttons" class="hide-if-no-js wp-media-buttons">';
  				do_action('media_buttons', $editor_id);
  				echo "</div>\n";
  			}
  			echo "</div>\n";
  		}
  
! 		$the_editor = apply_filters('the_editor', '<div id="wp-' . $editor_id . '-editor-container" class="wp-editor-container"><textarea' . $editor_class . $rows . $tabindex . ' cols="40" name="' . $set['textarea_name'] . '" id="' . $editor_id . '">%s</textarea></div>');
  		$content = apply_filters('the_editor_content', $content);
  
  		printf($the_editor, $content);
--- 135,148 ----
  				if ( !function_exists('media_buttons') )
  					include(ABSPATH . 'wp-admin/includes/media.php');
  
! 				echo '<div id="wp-' . $editor_id . '-media-buttons" class="wp-media-buttons">';
  				do_action('media_buttons', $editor_id);
  				echo "</div>\n";
  			}
  			echo "</div>\n";
  		}
  
! 		$the_editor = apply_filters('the_editor', '<div id="wp-' . $editor_id . '-editor-container" class="wp-editor-container"><textarea' . $editor_class . $height . $tabindex . ' cols="40" name="' . $set['textarea_name'] . '" id="' . $editor_id . '">%s</textarea></div>');
  		$content = apply_filters('the_editor_content', $content);
  
  		printf($the_editor, $content);
***************
*** 124,130 ****
  	}
  
  	public static function editor_settings($editor_id, $set) {
! 		global $editor_styles, $post;
  		$first_run = false;
  
  		if ( empty(self::$first_init) ) {
--- 152,158 ----
  	}
  
  	public static function editor_settings($editor_id, $set) {
! 		global $editor_styles;
  		$first_run = false;
  
  		if ( empty(self::$first_init) ) {
***************
*** 170,176 ****
  				$ext_plugins = '';
  
  				if ( $set['teeny'] ) {
! 					self::$plugins = $plugins = apply_filters( 'teeny_mce_plugins', array('inlinepopups', 'fullscreen', 'wordpress', 'wplink', 'wpdialogs'), $editor_id );
  				} else {
  					/*
  					The following filter takes an associative array of external plugins for TinyMCE in the form 'plugin_name' => 'url'.
--- 198,204 ----
  				$ext_plugins = '';
  
  				if ( $set['teeny'] ) {
! 					self::$plugins = $plugins = apply_filters( 'teeny_mce_plugins', array('inlinepopups', 'fullscreen', 'wordpress', 'wplink', 'wpdialogs' ), $editor_id );
  				} else {
  					/*
  					The following filter takes an associative array of external plugins for TinyMCE in the form 'plugin_name' => 'url'.
***************
*** 209,215 ****
  
  						foreach ( $mce_external_plugins as $name => $url ) {
  
! 							if ( is_ssl() ) $url = str_replace('http://', 'https://', $url);
  
  							$plugins[] = '-' . $name;
  
--- 237,243 ----
  
  						foreach ( $mce_external_plugins as $name => $url ) {
  
! 							$url = set_url_scheme( $url );
  
  							$plugins[] = '-' . $name;
  
***************
*** 310,323 ****
  					'keep_styles' => false,
  					'entities' => '38,amp,60,lt,62,gt',
  					'accessibility_focus' => true,
- 					'tabfocus_elements' => 'title,publish',
  					'media_strict' => false,
  					'paste_remove_styles' => true,
  					'paste_remove_spans' => true,
  					'paste_strip_class_attributes' => 'all',
  					'paste_text_use_dialog' => true,
  					'spellchecker_rpc_url' => self::$baseurl . '/plugins/spellchecker/rpc.php',
! 					'extended_valid_elements' => 'article[*],aside[*],audio[*],canvas[*],command[*],datalist[*],details[*],embed[*],figcaption[*],figure[*],footer[*],header[*],hgroup[*],keygen[*],mark[*],meter[*],nav[*],output[*],progress[*],section[*],source[*],summary,time[*],video[*],wbr',
  					'wpeditimage_disable_captions' => $no_captions,
  					'wp_fullscreen_content_css' => self::$baseurl . '/plugins/wpfullscreen/css/wp-fullscreen.css',
  					'plugins' => implode( ',', $plugins )
--- 338,351 ----
  					'keep_styles' => false,
  					'entities' => '38,amp,60,lt,62,gt',
  					'accessibility_focus' => true,
  					'media_strict' => false,
  					'paste_remove_styles' => true,
  					'paste_remove_spans' => true,
  					'paste_strip_class_attributes' => 'all',
  					'paste_text_use_dialog' => true,
+ 					'webkit_fake_resize' => false,
  					'spellchecker_rpc_url' => self::$baseurl . '/plugins/spellchecker/rpc.php',
! 					'schema' => 'html5',
  					'wpeditimage_disable_captions' => $no_captions,
  					'wp_fullscreen_content_css' => self::$baseurl . '/plugins/wpfullscreen/css/wp-fullscreen.css',
  					'plugins' => implode( ',', $plugins )
***************
*** 335,343 ****
  						$template_dir = get_template_directory();
  
  						foreach ( $editor_styles as $key => $file ) {
! 							if ( $file && file_exists( "$template_dir/$file" ) ) {
  								$mce_css[] = "$template_uri/$file";
- 							}
  						}
  					}
  
--- 363,370 ----
  						$template_dir = get_template_directory();
  
  						foreach ( $editor_styles as $key => $file ) {
! 							if ( $file && file_exists( "$template_dir/$file" ) )
  								$mce_css[] = "$template_uri/$file";
  						}
  					}
  
***************
*** 358,376 ****
  			}
  
  			if ( $set['teeny'] ) {
! 				$mce_buttons = apply_filters( 'teeny_mce_buttons', array('bold', 'italic', 'underline', 'blockquote', 'separator', 'strikethrough', 'bullist', 'numlist', 'justifyleft', 'justifycenter', 'justifyright', 'undo', 'redo', 'link', 'unlink', 'fullscreen'), $editor_id );
  				$mce_buttons_2 = $mce_buttons_3 = $mce_buttons_4 = array();
  			} else {
! 				$mce_buttons = apply_filters('mce_buttons', array('bold', 'italic', 'strikethrough', '|', 'bullist', 'numlist', 'blockquote', '|', 'justifyleft', 'justifycenter', 'justifyright', '|', 'link', 'unlink', 'wp_more', '|', 'spellchecker', 'fullscreen', 'wp_adv' ), $editor_id);
! 				$mce_buttons_2 = apply_filters('mce_buttons_2', array( 'formatselect', 'underline', 'justifyfull', 'forecolor', '|', 'pastetext', 'pasteword', 'removeformat', '|', 'charmap', '|', 'outdent', 'indent', '|', 'undo', 'redo', 'wp_help' ), $editor_id);
  				$mce_buttons_3 = apply_filters('mce_buttons_3', array(), $editor_id);
  				$mce_buttons_4 = apply_filters('mce_buttons_4', array(), $editor_id);
  			}
  
  			$body_class = $editor_id;
  
! 			if ( isset($post) )
! 				$body_class .= " post-type-$post->post_type";
  
  			if ( !empty($set['tinymce']['body_class']) ) {
  				$body_class .= ' ' . $set['tinymce']['body_class'];
--- 385,403 ----
  			}
  
  			if ( $set['teeny'] ) {
! 				$mce_buttons = apply_filters( 'teeny_mce_buttons', array('bold', 'italic', 'underline', 'blockquote', 'strikethrough', 'bullist', 'numlist', 'justifyleft', 'justifycenter', 'justifyright', 'undo', 'redo', 'link', 'unlink', 'fullscreen'), $editor_id );
  				$mce_buttons_2 = $mce_buttons_3 = $mce_buttons_4 = array();
  			} else {
! 				$mce_buttons = apply_filters('mce_buttons', array('bold', 'italic', 'strikethrough', 'bullist', 'numlist', 'blockquote', 'justifyleft', 'justifycenter', 'justifyright', 'link', 'unlink', 'wp_more', 'spellchecker', 'fullscreen', 'wp_adv' ), $editor_id);
! 				$mce_buttons_2 = apply_filters('mce_buttons_2', array( 'formatselect', 'underline', 'justifyfull', 'forecolor', 'pastetext', 'pasteword', 'removeformat', 'charmap', 'outdent', 'indent', 'undo', 'redo', 'wp_help' ), $editor_id);
  				$mce_buttons_3 = apply_filters('mce_buttons_3', array(), $editor_id);
  				$mce_buttons_4 = apply_filters('mce_buttons_4', array(), $editor_id);
  			}
  
  			$body_class = $editor_id;
  
! 			if ( $post = get_post() )
! 				$body_class .= ' post-type-' . $post->post_type;
  
  			if ( !empty($set['tinymce']['body_class']) ) {
  				$body_class .= ' ' . $set['tinymce']['body_class'];
***************
*** 398,406 ****
--- 425,437 ----
  				'theme_advanced_buttons2' => implode($mce_buttons_2, ','),
  				'theme_advanced_buttons3' => implode($mce_buttons_3, ','),
  				'theme_advanced_buttons4' => implode($mce_buttons_4, ','),
+ 				'tabfocus_elements' => $set['tabfocus_elements'],
  				'body_class' => $body_class
  			);
  
+ 			// The main editor doesn't use the TinyMCE resizing cookie.
+ 			$mceInit['theme_advanced_resizing_use_cookie'] = 'content' !== $editor_id || empty( $set['editor_height'] );
+ 
  			if ( $first_run )
  				$mceInit = array_merge(self::$first_init, $mceInit);
  
***************
*** 408,414 ****
  				$mceInit = array_merge($mceInit, $set['tinymce']);
  
  			// For people who really REALLY know what they're doing with TinyMCE
! 			// You can modify initArray to add, remove, change elements of the config before tinyMCE.init
  			// Setting "valid_elements", "invalid_elements" and "extended_valid_elements" can be done through this filter.
  			// Best is to use the default cleanup by not specifying valid_elements, as TinyMCE contains full set of XHTML 1.0.
  			if ( $set['teeny'] ) {
--- 439,445 ----
  				$mceInit = array_merge($mceInit, $set['tinymce']);
  
  			// For people who really REALLY know what they're doing with TinyMCE
! 			// You can modify $mceInit to add, remove, change elements of the config before tinyMCE.init
  			// Setting "valid_elements", "invalid_elements" and "extended_valid_elements" can be done through this filter.
  			// Best is to use the default cleanup by not specifying valid_elements, as TinyMCE contains full set of XHTML 1.0.
  			if ( $set['teeny'] ) {
***************
*** 538,562 ****
  		$baseurl = self::$baseurl;
  
  		if ( $tmce_on ) {
! 			if ( $compressed )
  				echo "<script type='text/javascript' src='{$baseurl}/wp-tinymce.php?c=1&amp;$version'></script>\n";
! 			else
  				echo "<script type='text/javascript' src='{$baseurl}/tiny_mce.js?$version'></script>\n";
  
  			if ( 'en' != self::$mce_locale && isset($lang) )
  				echo "<script type='text/javascript'>\n$lang\n</script>\n";
  			else
  				echo "<script type='text/javascript' src='{$baseurl}/langs/wp-langs-en.js?$version'></script>\n";
  		}
  ?>
  
  	<script type="text/javascript">
  		(function(){
! 			var init, ed, qt, first_init, mce = <?php echo wp_default_editor() == 'tinymce' ? 'true' : 'false'; ?>;
  
  			if ( typeof(tinymce) == 'object' ) {
  				// mark wp_theme/ui.css as loaded
! 				tinymce.DOM.files[tinymce.baseURI.getURI() + '/themes/advanced/skins/wp_theme/ui.css'] = true;
  
  				for ( ed in tinyMCEPreInit.mceInit ) {
  					if ( first_init ) {
--- 569,605 ----
  		$baseurl = self::$baseurl;
  
  		if ( $tmce_on ) {
! 			if ( $compressed ) {
  				echo "<script type='text/javascript' src='{$baseurl}/wp-tinymce.php?c=1&amp;$version'></script>\n";
! 			} else {
  				echo "<script type='text/javascript' src='{$baseurl}/tiny_mce.js?$version'></script>\n";
+ 				echo "<script type='text/javascript' src='{$baseurl}/wp-tinymce-schema.js?$version'></script>\n";
+ 			}
  
  			if ( 'en' != self::$mce_locale && isset($lang) )
  				echo "<script type='text/javascript'>\n$lang\n</script>\n";
  			else
  				echo "<script type='text/javascript' src='{$baseurl}/langs/wp-langs-en.js?$version'></script>\n";
  		}
+ 
+ 		$mce = ( self::$has_tinymce && wp_default_editor() == 'tinymce' ) || ! self::$has_quicktags;
  ?>
  
  	<script type="text/javascript">
+ 		var wpActiveEditor;
+ 
  		(function(){
! 			var init, ed, qt, first_init, DOM, el, i, mce = <?php echo (int) $mce; ?>;
  
  			if ( typeof(tinymce) == 'object' ) {
+ 				DOM = tinymce.DOM;
  				// mark wp_theme/ui.css as loaded
! 				DOM.files[tinymce.baseURI.getURI() + '/themes/advanced/skins/wp_theme/ui.css'] = true;
! 
! 				DOM.events.add( DOM.select('.wp-editor-wrap'), 'mousedown', function(e){
! 					if ( this.id )
! 						wpActiveEditor = this.id.slice(3, -5);
! 				});
  
  				for ( ed in tinyMCEPreInit.mceInit ) {
  					if ( first_init ) {
***************
*** 568,573 ****
--- 611,624 ----
  					if ( mce )
  						try { tinymce.init(init); } catch(e){}
  				}
+ 			} else {
+ 				if ( tinyMCEPreInit.qtInit ) {
+ 					for ( i in tinyMCEPreInit.qtInit ) {
+ 						el = tinyMCEPreInit.qtInit[i].id;
+ 						if ( el )
+ 							document.getElementById('wp-'+el+'-wrap').onmousedown = function(){ wpActiveEditor = this.id.slice(3, -5); }
+ 					}
+ 				}
  			}
  
  			if ( typeof(QTags) == 'function' ) {
***************
*** 576,604 ****
  				}
  			}
  		})();
! 
! 		var wpActiveEditor;
! 
! 		jQuery('.wp-editor-wrap').mousedown(function(e){
! 			wpActiveEditor = this.id.slice(3, -5);
! 		});
! 
! <?php
  
  		if ( self::$ext_plugins )
  			echo self::$ext_plugins . "\n";
  
  		if ( ! $compressed && $tmce_on ) {
! ?>
! 		(function(){var t=tinyMCEPreInit,sl=tinymce.ScriptLoader,ln=t.ref.language,th=t.ref.theme,pl=t.ref.plugins;sl.markDone(t.base+'/langs/'+ln+'.js');sl.markDone(t.base+'/themes/'+th+'/langs/'+ln+'.js');sl.markDone(t.base+'/themes/'+th+'/langs/'+ln+'_dlg.js');sl.markDone(t.base+'/themes/advanced/skins/wp_theme/ui.css');tinymce.each(pl.split(','),function(n){if(n&&n.charAt(0)!='-'){sl.markDone(t.base+'/plugins/'+n+'/langs/'+ln+'.js');sl.markDone(t.base+'/plugins/'+n+'/langs/'+ln+'_dlg.js');}});})();
! <?php
  		}
  
  		if ( !is_admin() )
  			echo 'var ajaxurl = "' . admin_url( 'admin-ajax.php', 'relative' ) . '";';
! ?>
! 	</script>
! <?php
  
  		if ( in_array('wplink', self::$plugins, true) || in_array('link', self::$qt_buttons, true) )
  			self::wp_link_dialog();
--- 627,649 ----
  				}
  			}
  		})();
! 		<?php
  
  		if ( self::$ext_plugins )
  			echo self::$ext_plugins . "\n";
  
  		if ( ! $compressed && $tmce_on ) {
! 			?>
! 			(function(){var t=tinyMCEPreInit,sl=tinymce.ScriptLoader,ln=t.ref.language,th=t.ref.theme,pl=t.ref.plugins;sl.markDone(t.base+'/langs/'+ln+'.js');sl.markDone(t.base+'/themes/'+th+'/langs/'+ln+'.js');sl.markDone(t.base+'/themes/'+th+'/langs/'+ln+'_dlg.js');sl.markDone(t.base+'/themes/advanced/skins/wp_theme/ui.css');tinymce.each(pl.split(','),function(n){if(n&&n.charAt(0)!='-'){sl.markDone(t.base+'/plugins/'+n+'/langs/'+ln+'.js');sl.markDone(t.base+'/plugins/'+n+'/langs/'+ln+'_dlg.js');}});})();
! 			<?php
  		}
  
  		if ( !is_admin() )
  			echo 'var ajaxurl = "' . admin_url( 'admin-ajax.php', 'relative' ) . '";';
! 
! 		?>
! 		</script>
! 		<?php
  
  		if ( in_array('wplink', self::$plugins, true) || in_array('link', self::$qt_buttons, true) )
  			self::wp_link_dialog();
***************
*** 610,616 ****
  	}
  
  	public static function wp_fullscreen_html() {
! 		global $content_width, $post;
  
  		$width = isset($content_width) && 800 > $content_width ? $content_width : 800;
  		$width = $width + 22; // compensate for the padding and border
--- 655,662 ----
  	}
  
  	public static function wp_fullscreen_html() {
! 		global $content_width;
! 		$post = get_post();
  
  		$width = isset($content_width) && 800 > $content_width ? $content_width : 800;
  		$width = $width + 22; // compensate for the padding and border
***************
*** 624,631 ****
  			<div id="wp-fullscreen-central-toolbar" style="width:<?php echo $width; ?>px;">
  
  			<div id="wp-fullscreen-mode-bar"><div id="wp-fullscreen-modes">
! 				<a href="#" onclick="fullscreen.switchmode('tinymce');return false;"><?php _e('Visual'); ?></a>
! 				<a href="#" onclick="fullscreen.switchmode('html');return false;"><?php _e('HTML'); ?></a>
  			</div></div>
  
  			<div id="wp-fullscreen-button-bar"><div id="wp-fullscreen-buttons" class="wp_themeSkin">
--- 670,677 ----
  			<div id="wp-fullscreen-central-toolbar" style="width:<?php echo $width; ?>px;">
  
  			<div id="wp-fullscreen-mode-bar"><div id="wp-fullscreen-modes">
! 				<a href="#" onclick="fullscreen.switchmode('tinymce');return false;"><?php _e( 'Visual' ); ?></a>
! 				<a href="#" onclick="fullscreen.switchmode('html');return false;"><?php _ex( 'Text', 'Name for the Text editor tab (formerly HTML)' ); ?></a>
  			</div></div>
  
  			<div id="wp-fullscreen-button-bar"><div id="wp-fullscreen-buttons" class="wp_themeSkin">
***************
*** 667,675 ****
  			</div></div>
  
  			<div id="wp-fullscreen-save">
! 				<span><?php if ( $post->post_status == 'publish' ) _e('Updated.'); else _e('Saved.'); ?></span>
! 				<img src="<?php echo admin_url('images/wpspin_light.gif'); ?>" alt="" />
! 				<input type="button" class="button-primary" value="<?php echo $save; ?>" onclick="fullscreen.save();" />
  			</div>
  
  			</div>
--- 713,721 ----
  			</div></div>
  
  			<div id="wp-fullscreen-save">
! 				<input type="button" class="button-primary right" value="<?php echo $save; ?>" onclick="fullscreen.save();" />
! 				<span class="spinner"></span>
! 				<span class="fs-saved"><?php if ( $post->post_status == 'publish' ) _e('Updated.'); else _e('Saved.'); ?></span>
  			</div>
  
  			</div>
***************
*** 768,780 ****
  		<div id="link-options">
  			<p class="howto"><?php _e( 'Enter the destination URL' ); ?></p>
  			<div>
! 				<label><span><?php _e( 'URL' ); ?></span><input id="url-field" type="text" tabindex="10" name="href" /></label>
  			</div>
  			<div>
! 				<label><span><?php _e( 'Title' ); ?></span><input id="link-title-field" type="text" tabindex="20" name="linktitle" /></label>
  			</div>
  			<div class="link-target">
! 				<label><input type="checkbox" id="link-target-checkbox" tabindex="30" /> <?php _e( 'Open link in a new window/tab' ); ?></label>
  			</div>
  		</div>
  		<?php $show_internal = '1' == get_user_setting( 'wplink', '0' ); ?>
--- 814,826 ----
  		<div id="link-options">
  			<p class="howto"><?php _e( 'Enter the destination URL' ); ?></p>
  			<div>
! 				<label><span><?php _e( 'URL' ); ?></span><input id="url-field" type="text" name="href" /></label>
  			</div>
  			<div>
! 				<label><span><?php _e( 'Title' ); ?></span><input id="link-title-field" type="text" name="linktitle" /></label>
  			</div>
  			<div class="link-target">
! 				<label><input type="checkbox" id="link-target-checkbox" /> <?php _e( 'Open link in a new window/tab' ); ?></label>
  			</div>
  		</div>
  		<?php $show_internal = '1' == get_user_setting( 'wplink', '0' ); ?>
***************
*** 782,814 ****
  		<div id="search-panel"<?php if ( ! $show_internal ) echo ' style="display:none"'; ?>>
  			<div class="link-search-wrapper">
  				<label>
! 					<span><?php _e( 'Search' ); ?></span>
! 					<input type="text" id="search-field" class="link-search-field" tabindex="60" autocomplete="off" />
! 					<img class="waiting" src="<?php echo esc_url( admin_url( 'images/wpspin_light.gif' ) ); ?>" alt="" />
  				</label>
  			</div>
  			<div id="search-results" class="query-results">
  				<ul></ul>
  				<div class="river-waiting">
! 					<img class="waiting" src="<?php echo esc_url( admin_url( 'images/wpspin_light.gif' ) ); ?>" alt="" />
  				</div>
  			</div>
  			<div id="most-recent-results" class="query-results">
  				<div class="query-notice"><em><?php _e( 'No search term specified. Showing recent items.' ); ?></em></div>
  				<ul></ul>
  				<div class="river-waiting">
! 					<img class="waiting" src="<?php echo esc_url( admin_url( 'images/wpspin_light.gif' ) ); ?>" alt="" />
  				</div>
  			</div>
  		</div>
  	</div>
  	<div class="submitbox">
  		<div id="wp-link-cancel">
  			<a class="submitdelete deletion" href="#"><?php _e( 'Cancel' ); ?></a>
  		</div>
- 		<div id="wp-link-update">
- 			<input type="submit" tabindex="100" value="<?php esc_attr_e( 'Add Link' ); ?>" class="button-primary" id="wp-link-submit" name="wp-link-submit">
- 		</div>
  	</div>
  	</form>
  	</div>
--- 828,860 ----
  		<div id="search-panel"<?php if ( ! $show_internal ) echo ' style="display:none"'; ?>>
  			<div class="link-search-wrapper">
  				<label>
! 					<span class="search-label"><?php _e( 'Search' ); ?></span>
! 					<input type="search" id="search-field" class="link-search-field" autocomplete="off" />
! 					<span class="spinner"></span>
  				</label>
  			</div>
  			<div id="search-results" class="query-results">
  				<ul></ul>
  				<div class="river-waiting">
! 					<span class="spinner"></span>
  				</div>
  			</div>
  			<div id="most-recent-results" class="query-results">
  				<div class="query-notice"><em><?php _e( 'No search term specified. Showing recent items.' ); ?></em></div>
  				<ul></ul>
  				<div class="river-waiting">
! 					<span class="spinner"></span>
  				</div>
  			</div>
  		</div>
  	</div>
  	<div class="submitbox">
+ 		<div id="wp-link-update">
+ 			<input type="submit" value="<?php esc_attr_e( 'Add Link' ); ?>" class="button-primary" id="wp-link-submit" name="wp-link-submit">
+ 		</div>
  		<div id="wp-link-cancel">
  			<a class="submitdelete deletion" href="#"><?php _e( 'Cancel' ); ?></a>
  		</div>
  	</div>
  	</form>
  	</div>
